const e = require("express");
const { Reader } = require("./models/Reader");
const { Helpers } = require("./Helpers");
const { AccessPolicy } = require("./models/AccessPolicy");
const { ReadersResponse } = require("./models/ReadersResponse");
const { ReaderPermissions } = require("./models/ReaderPermissions");


class DataAccess {

    static readers = [];

    static getAuthenticationUDCD(username, password, caseSensitivePassword, document)
    {
        console.log("get Authentication in DataAccess 1, readers length was " + this.readers.length);
        
        if (username && password && document)
        {
            for (var i = 0; i < this.readers.length; i++)
            {
                var reader = this.readers[i];
                if (caseSensitivePassword)
                {
                    console.log('caseSensitivePassword true before');

                    if (reader.Username.normalize() === username.normalize() && reader.Password.normalize() === password.normalize())
                    {
                        console.log('caseSensitivePassword true after, ', DataAccess.getAuthenticationHelper(reader, document));

                        return DataAccess.getAuthenticationHelper(reader, document);
                    }
                }
                else
                {
                    console.log('caseSensitivePassword false before');

                    if (reader.Username === username && DataAccess.ciEquals(reader.Password, password))
                    {
                        console.log('caseSensitivePassword false after');

                        return DataAccess.getAuthenticationHelper(reader, document);
                    }
                }
            }

            return DataAccess.getAuthenticationHelper(null, document);

        } else if (username)
        {
            for (var i = 0; i < this.readers.length; i++)
            {
                if (DataAccess.ciEquals(this.readers[i].Username, username))
                {
                    return DataAccess.getAuthenticationHelper(this.readers[i], document);
                }
            }

            return DataAccess.getAuthenticationHelper(null, document);
        }
    }

    static getAuthentication(id, document)
    {
        console.log("get Authentication in DataAccess 2");

        var reader;

        for (var i = 0; i < this.readers.length; i++)
        {
            if (this.readers[i].Id.normalize() === id.normalize())
            {
                reader = readers[i];
            }
        }

        return DataAccess.getAuthenticationHelper(reader, document);
    }

    static getAuthenticationByToken(token, document)
    {
        var reader;

        for (var i = 0; i < this.readers.length; i++)
        {

            if (token && this.readers[i].Token)
            {
                console.log('getAuthenticationByToken  2')
                if (this.readers[i].Token.normalize() === token.normalize())
                {
                    console.log('getAuthenticationByToken reader token was ' + this.readers[i].Token);

                    reader = this.readers[i];
                }
            }
        }

        if (!reader)
        {
            console.log('getAuthenticationByToken reader was null');
        }

        return DataAccess.getAuthenticationHelper(reader, document);
    }


    static getAuthenticationHelper(dataReader, document)
    {
        console.log('getAuthenticationHelper 1');

        if (!dataReader)
        {
            console.log('getAuthenticationHelper 1 fail 1');

            return Helpers.generateUnsuccessfulAuthenticationResult("Your account could not be found in the system. Make sure you are entering the correct details (3yq)");
        }

        if (dataReader.PurchaseRecords)
        {
            for (var i = 0; i < dataReader.PurchaseRecords.length; i++)
            {
                var entry = dataReader.PurchaseRecords[i];

                if (document.ExternalKey && entry.Product.ExternalKey)
                {
                    if (entry.Product.ExternalKey.normalize().toLowerCase() === document.ExternalKey.normalize().toLowerCase())
                    {
                        return Helpers.generateSuccessfulAuthenticationResult(DataAccess.convertDataReaderToReader(dataReader), DataAccess.convertDataPurchaseRecordToAccessPolicy(entry));
                    }
                }
            };
        }
        else
        {
            console.log('dataReader had no purchase records');
        }

        console.log('getAuthenticationHelper 1 fail 2');

        return Helpers.generateUnsuccessfulAuthenticationResult("You do not have permission to view this content (w29)", dataReader.Id, dataReader.Username);
    }

    static getReaderByToken(token)
    {
        //update this code to talk to your system

        for (var i = 0; i < dataReader.PurchaseRecords.length; i++)
        {
            if (DataAccess.ciEquals(dataReader.PurchaseRecords[i].Token, token))
            {
                return convertDataReaderToReader(dataReader.PurchaseRecords[i]);
            }
        }
    }

    static getReaderByUsername(username)
    {
        for (var i = 0; i < this.readers.length; i++)
        {
            if (DataAccess.ciEquals(this.readers[i].Username, username))
            {
                return DataAccess.convertDataReaderToReader(this.readers[i]);
            }
        }
    }

    static getReaderByUsernameAndPassword(username, password, caseSensitivePassword)
    {
        for (var i = 0; i < this.readers.length; i++)
        {
            if (!caseSensitivePassword)
            {
                if (DataAccess.ciEquals(username, this.readers[i].Username) && password.normalize() === this.readers[i].Password.normalize())
                {
                    return DataAccess.convertDataReaderToReader(this.readers[i]);
                }
            }
            else
            {
                if (username.normalize() === this.readers[i].Username.normalize() && password.normalize() === this.readers[i].Password.normalize())
                {
                    return DataAccess.convertDataReaderToReader(this.readers[i]);
                }
            }
        }
    }

    static getAuthentication(username, document)
    {
        console.log("get Authentication in DataAccess 3");

        var dataReader;

        for (var i = 0; i < this.readers.length; i++)
        {
            if (this.readers[i].Username.toLowerCase() === username.toLowerCase())
            {
                dataReader = this.readers[i];
            }
        }

        return DataAccess.getAuthenticationHelper(dataReader, document);
    }

    static getReaderPermissions(id)
    {
        var datareader;

        for (var i = 0; i < this.readers.length; i++)
        {

            console.log('getReaderPermissions id was ' + id);
            console.log('getReaderPermissions this.readers[i].Id was ' + this.readers[i].Id);
            if (this.readers[i].Id.toLowerCase() === id.toLowerCase())
            {
                datareader = this.readers[i];
            }
        }

        var rp = new ReaderPermissions();

        if (datareader != null && datareader.PurchaseRecords != null)
        {
            rp.docExternalKeys = [];
            for (var j = 0; j < datareader.PurchaseRecords.length; j++)
            {
                rp.docExternalKeys.push(datareader.PurchaseRecords[j].ExternalKey);
            }

            
        }
        return rp;
    }

    static convertDataReaderToReader(dr)
    {
        if (dr)
        {
            var reader = new Reader(dr.Id, dr.Username);
            reader.Password = "";
            reader.IsActive = true;
            return reader;
        }
    }

    static convertDataPurchaseRecordToAccessPolicy(pr)
    {
        if (pr)
        {
            var ap = new AccessPolicy("");
            ap.OfflineDurationinDays = pr.OfflineDays;
            ap.ComputersMax = -1;
            ap.PdfLimit = pr.PdfLimit;
            ap.BrowserLimit = pr.BrowserLimit;
            return ap;
        }
    }

    // performs case insensitive string comparison in JavaScript
    static ciEquals(a, b) {
        return typeof a === 'string' && typeof b === 'string'
            ? a.localeCompare(b, undefined, { sensitivity: 'accent' }) === 0
            : a === b;
    }

    static populateTestReaders()
    {
        //clear all readers first
        this.readers = [];

        var tr = new Reader("1", "username1");
        tr.PurchaseRecords = [];
        tr.Password = '12345';
        var p = new DataProduct('exampleKey');
        p.ExternalKey = 'exampleKey';

        // user with username1 has a purchase record
        var pr = new DataPurchaseRecord(-1, -1, -1, p);
        pr.ExternalKey = 'exampleKey';
        tr.PurchaseRecords.push(pr);
        tr.Token = '3BBD5CC2-954A-40A1-8653-C14D8B4B4824';

        this.readers.push(tr);

        for (var i = 2; i < 100; i++)
        {
            var tr = new Reader("" + i, "username" + i);
            tr.PurchaseRecords = [];
            tr.Password = '12345';
            var p = new DataProduct('exampleKey');
            p.ExternalKey = 'exampleKey';

            this.readers.push(tr);
        }

        console.log("Populated DataAccess.readers array with " + this.readers.length + " test readers");
    }

    static createTestResponse()
    {
        var tr = DataAccess.createTestReader();
        var testReaders = [ tr ];
        return new ReadersResponse(testReaders);
    }

    static getReaders(page, filter, sort)
    {
        var res = [];

        if (filter) 
        {
            filter=JSON.parse(filter);

            for (var i = 0; i < this.readers.length; i++)
            {
                if (this.readers[i].Username.toLowerCase().includes(filter.contains))
                {
                    res.push(this.readers[i]);
                }
            }
        }
        else
        {
            res = this.readers;
        }

        if (sort) 
        {
            res.sort((a, b) => (a.Username < b.Username) ? 1 : -1);
        }

        if (page) 
        {
            page = JSON.parse(page);
            var startIndex = (page.index - 1) * page.size;
            res = res.slice(startIndex, startIndex + page.size);
        }

        return new ReadersResponse(res, this.readers.length);
    }

    static createTestReader()
    {
        var id = 1; //Math.floor(Math.random() * 10000000); // random id between 0 and 10000000
        var r = new Reader(id, "username" + id);
        r.Password = '12345';
        r.Token = '3BBD5CC2-954A-40A1-8653-C14D8B4B4824';
        return r;
    }
}

class DataReader
{
    Id;
    Username;
    Password;
    Token;
    PurchaseRecords;
}

class DataPurchaseRecord
{
      OfflineDays;
      BrowserLimit;
      PdfLimit;
      Product;

    constructor(OfflineDays, BrowserLimit, PdfLimit, Product)
    {
        this.OfflineDays = OfflineDays;
        this.BrowserLimit = BrowserLimit;
        this.PdfLimit = PdfLimit;
        this.Product = Product;
    }
}

class DataProduct
{
    ExternalKey;
    constructor(ExternalKey)
    {
        this.ExternalKey = ExternalKey;
    }
}

module.exports.DataAccess = DataAccess;