const { AuthenticationResponse } = require("./models/AuthenticationResponse");

class Helpers {
    static generateUnsuccessfulAuthenticationResult(message, userId, userName)
    {
        var res = new AuthenticationResponse(false);
        res.Message = message;

        if (userId)
        {
            res.UserId = userId;
        }

        if (userName)
        {
            res.Username = userName;
        }

        return res;
    }

    static generateSuccessfulAuthenticationResult(reader, accessPolicy = null)
    {
        if (reader === null)
        {
            console.log('fail');
            return new AuthenticationResponse(false);
        }

        if (!accessPolicy)
        {
            console.log('access policy was null in generateSuccessfulAuthenticationResult');
        }
        else
        {
            console.log('access policy was not null ', accessPolicy);
        }

        var res = new AuthenticationResponse(true);
        res.UserId = reader.Id;
        res.Username = reader.Username;
        res.WatermarkTokens = { "CustomWatermark": ("Custom watermark for " + reader.Username) };

        return res;
    }
}

module.exports.Helpers = Helpers;