const readers = require('./routes/Readers.js');
const authenticate = require('./routes/Authenticate.js');
const permissions = require('./routes/Permissions.js');

const express = require('express');
const { DataAccess } = require('./DataAccess.js');
const app = express();
const port = 8000;

app.use(express.json());
app.use(express.urlencoded({
    extended: true
}));

app.use('/readers', readers);
app.use('/authenticate', authenticate.router);
app.use('/permissions', permissions);

console.log('Starting...');

app.listen(port);

DataAccess.populateTestReaders();